﻿using IllusionPlugin;
using UnityEngine.SceneManagement;

namespace BeatLyrics
{
    /// <summary>
    ///   Entry point of the plugin.
    /// </summary>
    public sealed class Plugin : IPlugin
    {
        public string Name => "Beat Lyrics";
        public string Version => "0.0.0.1";

        private LyricsComponent _lastUsedLyricsComponent;

        public void OnApplicationStart()
        {
            SceneManager.activeSceneChanged += OnActiveSceneChanged;
        }

        public void OnApplicationQuit()
        {
            SceneManager.activeSceneChanged -= OnActiveSceneChanged;
        }

        #region Unused

        public void OnLevelWasInitialized(int level)
        {
        }

        public void OnLevelWasLoaded(int level)
        {
        }

        public void OnUpdate()
        {
        }

        public void OnFixedUpdate()
        {
        }

        #endregion Unused

        public void OnActiveSceneChanged(Scene _, Scene newScene)
        {
            if (newScene.name == "GameCore")
            {
                _lastUsedLyricsComponent = newScene.GetRootGameObjects()[0].AddComponent<LyricsComponent>();
            }
            else
            {
                if (_lastUsedLyricsComponent != null)
                {
                    //TODO: free resources
                }
            }
        }
    }
}
